using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Docking;
using Telerik.WinControls.UI;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.Primitives;

namespace TabWithCloseButton
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            this.AddNewTab();
        }

        private void AddNewTab()
        {
            DocumentPane panel = new DocumentPane();
            panel.Text = "Pane";

            this.dockingManager1.SetDocument(panel);
            this.AddCloseButtonToPane(panel);
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private RadButtonElement CreateNewButtonElement()
        {
            RadButtonElement ret = new Telerik.WinControls.UI.RadButtonElement();
            (ret.Children[0] as Telerik.WinControls.Primitives.FillPrimitive).BackColor = 
                System.Drawing.Color.Transparent;
            (ret.Children[0] as Telerik.WinControls.Primitives.FillPrimitive).BackColor2 = 
                System.Drawing.Color.Transparent;
            (ret.Children[0] as Telerik.WinControls.Primitives.FillPrimitive).BackColor3 = 
                System.Drawing.Color.Transparent;
            (ret.Children[2] as Telerik.WinControls.Primitives.BorderPrimitive).Visibility = 
                Telerik.WinControls.ElementVisibility.Collapsed;

            ret.MaxSize = new System.Drawing.Size(16, 16);

            ret.Text = "X";
            ret.ForeColor = System.Drawing.Color.Red;
            ret.DisplayStyle = Telerik.WinControls.DisplayStyle.Text;
            ret.Alignment = System.Drawing.ContentAlignment.MiddleRight;

            return ret;
        }

        private void AddCloseButtonToPane(DocumentPane documentPane)
        {
            StackLayoutPanel layoutPanel = new StackLayoutPanel();
            layoutPanel.Alignment = ContentAlignment.MiddleRight;

            TabItem tab = (TabItem)documentPane.DockableTab;
            ImageAndTextLayoutPanel currentLayout = (ImageAndTextLayoutPanel)tab.Children[2];
            currentLayout.Margin = new Padding(0, 0, 20, 0);

            RadButtonElement buttonElement = this.CreateNewButtonElement();
            buttonElement.Tag = documentPane;
            buttonElement.Click += new EventHandler(TabButton_Click); 
            //button.MouseEnter += new EventHandler(closeButton_MouseEnter);
            //button.MouseLeave += new EventHandler(closeButton_MouseLeave);

            layoutPanel.Children.Add(buttonElement);
            tab.Children.Add(layoutPanel);
            ((BorderPrimitive)tab.Children[1]).ZIndex = 1;

        }

        void TabButton_Click(object sender, EventArgs e)
        {
            DocumentPane pane = ((DocumentPane)((RadButtonElement)sender).Tag);

            this.dockingManager1.RemoveDocument(pane);
        }



    }
}